/* Beispielprogramm 2.15 aus                          */
/* C. Vogt, Nebenlaeufige Programmierung, Hanser 2012 */

/* Unterbrechung eines Threads mit interrupt() */

// Thread: Er gibt in einer Schleife einen Text wiederholt aus.
// Sobald von auen die Methode interrupt() aufgerufen wird,
// verlsst er die Schleife.

class BeispielThread extends Thread {

 public void run() {
   while (!isInterrupted())
    System.out.println("Hier ist der Thread");
 }
 
}

// Hauptprogramm: Erzeugt einen BeispielThread, blockiert sich fr
// zwei Sekunden und terminiert den Thread dann wieder.

public class Prog_2_15 {  // Name im Buch: ThreadInterrupt

 public static void main(String[] args) {
 
  BeispielThread t = new BeispielThread();
  t.start();
  try {
    Thread.currentThread().sleep(2000);
  } catch (InterruptedException e) {}
  t.interrupt();
  System.out.println("Thread ist beendet");
 }
 
}
